diff --git a/arch/arm/cpu/armv7/Kconfig b/arch/arm/cpu/armv7/Kconfig
index 1697e61..e12d469 100644
--- a/arch/arm/cpu/armv7/Kconfig
+++ b/arch/arm/cpu/armv7/Kconfig
@@ -7,14 +7,14 @@ config CPU_V7_HAS_VIRT
         bool
 
 config ARMV7_NONSEC
-	boolean "Enable support for booting in non-secure mode" if EXPERT
+	bool "Enable support for booting in non-secure mode" if EXPERT
 	depends on CPU_V7_HAS_NONSEC
 	default y
 	---help---
 	Say Y here to enable support for booting in non-secure / SVC mode.
 
 config ARMV7_BOOT_SEC_DEFAULT
-	boolean "Boot in secure mode by default" if EXPERT
+	bool "Boot in secure mode by default" if EXPERT
 	depends on ARMV7_NONSEC
 	default y if TEGRA
 	---help---
@@ -25,7 +25,7 @@ config ARMV7_BOOT_SEC_DEFAULT
 	variable to "sec" or "nonsec".
 
 config ARMV7_VIRT
-	boolean "Enable support for hardware virtualization" if EXPERT
+	bool "Enable support for hardware virtualization" if EXPERT
 	depends on CPU_V7_HAS_VIRT && ARMV7_NONSEC
 	default y
 	---help---
@@ -43,7 +43,7 @@ config ARMV7_PSCI_NR_CPUS
 	default 4
 
 config ARMV7_LPAE
-	boolean "Use LPAE page table format" if EXPERT
+	bool "Use LPAE page table format" if EXPERT
 	depends on CPU_V7
 	select PHYS_64BIT
 	default n
diff --git a/arch/arm/cpu/armv8/Kconfig b/arch/arm/cpu/armv8/Kconfig
index acf2460..7e1fc4c 100644
--- a/arch/arm/cpu/armv8/Kconfig
+++ b/arch/arm/cpu/armv8/Kconfig
@@ -1,7 +1,7 @@
 if ARM64
 
 config ARMV8_MULTIENTRY
-        boolean "Enable multiple CPUs to enter into U-Boot"
+        bool "Enable multiple CPUs to enter into U-Boot"
 
 config ARMV8_SPIN_TABLE
 	bool "Support spin-table enable method"
diff --git a/board/sunxi/Kconfig b/board/sunxi/Kconfig
index 323e972..1b30669 100644
--- a/board/sunxi/Kconfig
+++ b/board/sunxi/Kconfig
@@ -249,7 +249,7 @@ config UART0_PORT_F
 	Only enable this if you really know what you are doing.
 
 config OLD_SUNXI_KERNEL_COMPAT
-	boolean "Enable workarounds for booting old kernels"
+	bool "Enable workarounds for booting old kernels"
 	default n
 	---help---
 	Set this to enable various workarounds for old kernels, this results in
@@ -419,13 +419,13 @@ config I2C4_ENABLE
 endif
 
 config AXP_GPIO
-	boolean "Enable support for gpio-s on axp PMICs"
+	bool "Enable support for gpio-s on axp PMICs"
 	default n
 	---help---
 	Say Y here to enable support for the gpio pins of the axp PMIC ICs.
 
 config VIDEO
-	boolean "Enable graphical uboot console on HDMI, LCD or VGA"
+	bool "Enable graphical uboot console on HDMI, LCD or VGA"
 	depends on !MACH_SUN8I_A83T && !MACH_SUN8I_H3 && !MACH_SUN9I && !MACH_SUN50I_A64
 	default y
 	---help---
@@ -434,21 +434,21 @@ config VIDEO
 	info on how to select the video output and mode.
 
 config VIDEO_HDMI
-	boolean "HDMI output support"
+	bool "HDMI output support"
 	depends on VIDEO && !MACH_SUN8I
 	default y
 	---help---
 	Say Y here to add support for outputting video over HDMI.
 
 config VIDEO_VGA
-	boolean "VGA output support"
+	bool "VGA output support"
 	depends on VIDEO && (MACH_SUN4I || MACH_SUN7I)
 	default n
 	---help---
 	Say Y here to add support for outputting video over VGA.
 
 config VIDEO_VGA_VIA_LCD
-	boolean "VGA via LCD controller support"
+	bool "VGA via LCD controller support"
 	depends on VIDEO && (MACH_SUN5I || MACH_SUN6I || MACH_SUN8I)
 	default n
 	---help---
@@ -457,7 +457,7 @@ config VIDEO_VGA_VIA_LCD
 	Olimex A13 boards.
 
 config VIDEO_VGA_VIA_LCD_FORCE_SYNC_ACTIVE_HIGH
-	boolean "Force sync active high for VGA via LCD controller support"
+	bool "Force sync active high for VGA via LCD controller support"
 	depends on VIDEO_VGA_VIA_LCD
 	default n
 	---help---
@@ -475,7 +475,7 @@ config VIDEO_VGA_EXTERNAL_DAC_EN
 	format understood by sunxi_name_to_gpio, e.g. PH1 for pin 1 of port H.
 
 config VIDEO_COMPOSITE
-	boolean "Composite video output support"
+	bool "Composite video output support"
 	depends on VIDEO && (MACH_SUN4I || MACH_SUN5I || MACH_SUN7I)
 	default n
 	---help---
diff --git a/drivers/power/Kconfig b/drivers/power/Kconfig
index b422703..f2c5629 100644
--- a/drivers/power/Kconfig
+++ b/drivers/power/Kconfig
@@ -15,12 +15,12 @@ choice
 	default SUNXI_NO_PMIC if MACH_SUN8I_H3 || MACH_SUN50I
 
 config SUNXI_NO_PMIC
-	boolean "board without a pmic"
+	bool "board without a pmic"
 	---help---
 	Select this for boards which do not use a PMIC.
 
 config AXP152_POWER
-	boolean "axp152 pmic support"
+	bool "axp152 pmic support"
 	depends on MACH_SUN5I
 	select CMD_POWEROFF
 	---help---
@@ -28,7 +28,7 @@ config AXP152_POWER
 	A10s boards.
 
 config AXP209_POWER
-	boolean "axp209 pmic support"
+	bool "axp209 pmic support"
 	depends on MACH_SUN4I || MACH_SUN5I || MACH_SUN7I
 	select CMD_POWEROFF
 	---help---
@@ -36,7 +36,7 @@ config AXP209_POWER
 	A10, A13 and A20 boards.
 
 config AXP221_POWER
-	boolean "axp221 / axp223 pmic support"
+	bool "axp221 / axp223 pmic support"
 	depends on MACH_SUN6I || MACH_SUN8I_A23 || MACH_SUN8I_A33
 	select CMD_POWEROFF
 	---help---
@@ -44,14 +44,14 @@ config AXP221_POWER
 	A23 and A31 boards.
 
 config AXP809_POWER
-	boolean "axp809 pmic support"
+	bool "axp809 pmic support"
 	depends on MACH_SUN9I
 	select CMD_POWEROFF
 	---help---
 	Say y here to enable support for the axp809 pmic found on A80 boards.
 
 config AXP818_POWER
-	boolean "axp818 pmic support"
+	bool "axp818 pmic support"
 	depends on MACH_SUN8I_A83T
 	select CMD_POWEROFF
 	---help---
@@ -59,7 +59,7 @@ config AXP818_POWER
 	A83T dev board.
 
 config SY8106A_POWER
-	boolean "SY8106A pmic support"
+	bool "SY8106A pmic support"
 	depends on MACH_SUN8I_H3
 	---help---
 	Select this to enable support for the SY8106A pmic found on some
diff --git a/drivers/spmi/Kconfig b/drivers/spmi/Kconfig
index 8d25b45..ab4878e 100644
--- a/drivers/spmi/Kconfig
+++ b/drivers/spmi/Kconfig
@@ -9,13 +9,13 @@ config SPMI
 	  to connect PMIC devices on various SoCs.
 
 config SPMI_MSM
-	boolean "Support Qualcomm SPMI bus"
+	bool "Support Qualcomm SPMI bus"
 	depends on SPMI
 	---help---
 	  Support SPMI bus implementation found on Qualcomm Snapdragon SoCs.
 
 config SPMI_SANDBOX
-	boolean "Support for Sandbox SPMI bus"
+	bool "Support for Sandbox SPMI bus"
 	depends on SPMI
 	---help---
 	  Demo SPMI bus implementation. Emulates part of PM8916 as single